      program bigtest1
      real sum
      integer i, ierr, nproc, iam, ncalls
      character*12 initstr

      include 'mpif.h'

      call mpi_init(ierr)
      call mpi_comm_size(MPI_COMM_WORLD, nproc, ierr)
      call mpi_comm_rank(MPI_COMM_WORLD, iam, ierr)

      ncalls = 8000
      write(initstr,'(''bigtest1.'',i3.3)') iam

      call PBINIT(initstr)

      call PBSTART('bigtest1')

      sum = 0.0
      do i = 1, ncalls
        call work(sum)
      enddo

      call comm()

      print *,'sum: ',sum
      call PBEND('bigtest1')
      call PBREPORT()
      call mpi_finalize(ierr)

      end

      subroutine work(sum)
      real a(1000)
      real b(1000)
      real sum,sum1,sum2
      integer i,j, ntimes

      ntimes = 10000  ! 3200000

      call PBSTART('work')

      do i = 1,1000
        a(i) = 1.0
        b(i) = 2.0
      enddo


      call PBSTART('work:block1')
      sum1 = 0.0
      do j = 1,ntimes
        do i = 1,1000
          sum1 = sum1 + a(i)*b(i)
        enddo
      enddo 
      sum = sum + sum1
      call PBEND('work:block1')

      call PBSTART('work:block2')
      sum2 = 0.0
      do j = 1,ntimes
        do i = 1,1000
          sum2 = sum2 + a(i)*b(i)
        enddo
      enddo 
      sum = sum + sum2
      call PBEND('work:block2')

      call PBEND('work')
      return
      end

      subroutine comm()

      ! This is a fake comm program
      call PBSTART('comm')

      
      call PBSTART('comm:mpi')
      call PBCOMM(1000)  ! sending 1000 bytes;
      ! call MPI_send()
      call PBEND('comm:mpi')

      call PBSTART('comm:mpi')
      call PBCOMM(1000)  ! receiving 1000 bytes;
      ! call MPI_recv

      call PBEND('comm:mpi')

      call PBEND('comm')

      return
      end

