#include "fpapi.h"
      program bigtest2
      real sum
      real*8 flops
      integer i, ierr, nproc, iam, ncalls
      character*12 initstr
      integer EventSet, check
      integer*8 values(1)

      include 'mpif.h'

      call mpi_init(ierr)
      call mpi_comm_size(MPI_COMM_WORLD, nproc, ierr)
      call mpi_comm_rank(MPI_COMM_WORLD, iam, ierr)

      call papidbg(iam)

      check = PAPI_VER_CURRENT
      call PAPIf_library_init( check )
      call PAPIf_create_eventset(EventSet,check)
      call PAPIf_add_event(EventSet, PAPI_FP_INS, check)

      call PAPIf_start( EventSet, check )

      ncalls = 4700

      sum = 0.0
      do i = 1, ncalls
        call work(sum)
      enddo

      print *,' sum: ',sum

      call PAPIf_stop(EventSet, values, check)
      call PAPIf_reset(EventSet, check)

      flops = values(1)
      print 1000, iam, flops

      call mpi_finalize(ierr)

 1000 format(1x,'Iam: ',i3,' Flops: ',1pg15.7)
      end

      subroutine work(sum)
      real a(100)
      real b(100)
      real sum,sum1,sum2
      integer i,j, ntimes

      ntimes = 200000 

      do i = 1,100
        a(i) = 1.0
        b(i) = 2.0
      enddo


      sum1 = 0.0
      do j = 1,ntimes
        do i = 1,100
          sum1 = sum1 + 3.0*a(i)*b(i)
        enddo
      enddo 
      sum = sum + sum1

      return
      end


