#include <stdio.h>
#define USE_PB
#include "pbUser.h"

void work(double* sum);
void comm(void);

int main()
{
  double sum;
  static void *pbptr = 0;

#ifdef USE_PB
  PBinit("ctest1","PAPI_FP_INS:PAPI_TOT_INS");
  PBstart("ctest1",&pbptr);
#endif

  sum = 0.0;

  work(&sum);
  work(&sum);

  printf("sum: %11.3g\n",sum);
  comm();
  ENDPB(ctest1);
  REPORTPB();
}

void work(double* xsum)
{
  STARTPB(work)
  int    i,j;
  double a[1000], b[1000];
  double sum = *xsum;
  static void *pbptr1 = 0;
  static void *pbptr2 = 0;

  for (i = 0; i < 1000; i++)
    {
      a[i] = 1.0;
      b[i] = 2.0;
    }

  STARTPB_BLK(work:block1,&pbptr1);
  for (j = 0; j < 10000; j++)
    for (i = 0; i < 1000; i++)
      sum += a[i]*b[i];
  
  ENDPB(work:block1);

  STARTPB_BLK(work:block2,&pbptr2);
  for (j = 0; j < 10000; j++)
    for (i = 0; i < 1000; i++)
      sum += a[i]*b[i];
  
  ENDPB(work:block2);

  *xsum = sum;
  ENDPB(work);
}
	
  
void comm(void)
{
  STARTPB(comm)
  /* Fake comm routine */

  static void *pbptr = 0;


  STARTPB_BLK(comm:mpi,&pbptr);
  COMMBytesPB(1000);
  /* mpi_send()*/
  ENDPB(comm:mpi);

  STARTPB_BLK(comm:mpi,&pbptr);
  COMMBytesPB(1000);
  /* mpi_recv()*/
  ENDPB(comm:mpi);

  ENDPB(comm);
}
