/*
 * 
 * Copyright (c) 2001-2002 Robert McLay
 *
 * Authors: Robert McLay <mclay@cfdlab.ae.utexas.edu>
 *          Victor Parr  <vparr@mindspring.com>
 */

/*
 * This file is part of PB: PerfBench.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef MEASURE_H_Included
#define MEASURE_H_Included

#if (defined(_CRAYMPP))
#  include <time.h>
#  define START_TIMER(t)      t = rtclock()*SecPerClk
#  define END_TIMER(t)        t = rtclock()*SecPerClk
#  define START_WALL_TIMER(t) START_TIMER(t)
#  define END_WALL_TIMER(t)   END_TIMER(t)   
#  define INITIALIZE_TIMER    SecPerClk = tckclk_init()
#else
#  define START_TIMER(t)      cputime(&t)
#  define END_TIMER(t)        cputime(&t)
#  define START_WALL_TIMER(t) walltime(&t)
#  define END_WALL_TIMER(t)   walltime(&t)
#  define INITIALIZE_TIMER    tckclk_init()
#endif
extern double SecPerClk;

#if (defined(_CRAY) && !defined(_CRAYMPP))
  float cputime(float *t);
#else
  double cputime(double * t);
#endif

double tckclk_init(void);

#if (defined(_CRAY) && !defined(_CRAYMPP))
  float walltime(float *t);
#else
  double walltime(double * t);
#endif


int counter_init(int nEvents, int* eventList);

int counter_read(INT64* cnt);


#endif /* MEASURE_H_Included */


