/*
 * 
 * Copyright (c) 2001-2002 Robert McLay
 *
 * Authors: Robert McLay <mclay@cfdlab.ae.utexas.edu>
 *          Victor Parr  <vparr@mindspring.com>
 */

/*
 * This file is part of PB: PerfBench.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PB_H_Included
#define PB_H_Included

#if (defined(sun) || defined(SUN) || defined(__sun__) || defined(MIPS) || defined(__mips) || defined(__mips__) || defined(__alpha) || defined(_IBMR2) || defined(__IPSC__) || defined(__GNUC__) || defined(__hp9000s700) || defined(__hp9000s800) || defined(__LCC__) || (defined(__PGI)))
#  ifndef BSD_FOR_TYPE
#    define BSD_FOR_TYPE 1
#  endif
#elif (defined(CRAY))
#  include <fortran.h>
#  ifndef CRAY_FOR_TYPE
#    define CRAY_FOR_TYPE 1
#  endif
#else
#  error "Unknown Machine Type: Must Create Fortran interface"
#endif

#ifndef PASTE2
#  define PASTE2(a,b) gEnErIcPaste2(a,b)
#  define gEnErIcPaste2(a,b) a##b
#endif

#if (defined(BSD_FOR_TYPE))
#  define COMMON_EXTERN extern
#  define BSD_FSTRING 1
#  define CP2FCD(cp,len,fcd) do{fcd = cp; PASTE2(fcd,_len)=len;}while(0)
#  define FCD2CP(s) s
#  define FCDLEN(s) PASTE2(s,_len)
#  define FDESC(s) char * s; static int PASTE2(s,_len)
#  define FSTRING(a,comma) comma char * a
#  define protoFSTRING(a)  char * a
#  define protoLenFSTRING(a) , int PASTE2(a,_len)
#  if (defined(_IBMR2))
#    define FORTRAN_NAME(UN,ln) ln
#  else
#    define FORTRAN_NAME(UN,ln) PASTE2(ln,_)
#  endif
#endif

#if (defined(CRAY_FOR_TYPE))
#  define COMMON_EXTERN 
#  define CP2FCD(cp,len,fcd) fcd = _cptofcd(cp,len)
#  define FCD2CP(s) _fcdtocp(s)
#  define FDESC(s) _fcd s
#  define FCDLEN(s) _fcdlen(s)
#  define FORTRAN_NAME(UN,ln) UN
#  define FSTRING(a,comma) comma _fcd a
#  define protoFSTRING(a) _fcd a
#  define protoLenFSTRING(a)
#endif

#define PB_init      FORTRAN_NAME(PBINIT,   pbinit)
#define PB_final     FORTRAN_NAME(PBFINAL,  pbfinal)
#define PB_report    FORTRAN_NAME(PBREPORT, pbreport)
   
#define PB_start     FORTRAN_NAME(PBSTART,  pbstart)
#define PB_end       FORTRAN_NAME(PBEND,    pbend)
#define PB_commBytes FORTRAN_NAME(PBCOMM,   pbcomm)
#define PB_ioBytes   FORTRAN_NAME(PBIO,     pbio)

#ifndef STRCMP
#  define STRCMP(a,test,b) (strcmp((a),(b)) test 0)
#  define STRNCMP(a,test,b,n) (strncmp((a),(b),(n)) test 0)
#  define STRCASECMP(a,test,b) (strcasecmp((a),(b)) test 0)
#  define STRNCASECMP(a,test,b,n) (strncasecmp((a),(b),(n)) test 0)
#endif
#ifndef MAX
#  define MAX(a,b) (((a) > (b)) ? (a) : (b))
#  define MIN(a,b) (((a) < (b)) ? (a) : (b))
#endif

#define ALLOC(x,s,t) do { x = (t) malloc((s)); if (x == 0) \
                         {fprintf(stderr,"%s:%d:%s\n",__FILE__,__LINE__,"Memory allocation failed");\
                                exit(1);}} while(0)
#define REALLOC(x,s,t) do { x = (t) realloc((x),(s)); if (x == 0) \
                            {fprintf(stderr,"%s:%d:%s\n",__FILE__,__LINE__,"Memory allocation failed"));\
                                     exit(1);}} while(0)

#define Values(i,ievent) values[(i) + 4*(ievent)]
typedef enum {START=0, ACC, TtlSTART, TtlACC} SumTypes_t;
typedef struct
{
  char*  key;
  int    len;    
  double startCpu;
  double startWall;
  double startCpuTtl;
  double startWallTtl;
  double accCpu;
  double accWall;
  double accCpuTtl;
  double accWallTtl;
  INT64  callCount;
  INT64  commBytes;
  INT64  ioBytes;
  INT64  values[4];
} PBRecord;


#endif /* PB_H_Included */


