/*
 * 
 * Copyright (c) 2001-2002 Robert McLay
 *
 * Authors: Robert McLay <mclay@cfdlab.ae.utexas.edu>
 *          Victor Parr  <vparr@mindspring.com>
 */

/*
 * This file is part of PB: PerfBench.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PB_USER_H_Included
#define PB_USER_H_Included

#ifndef PASTE2
#  define PASTE2(a,b) gEnErIcPaste2(a,b)
#  define gEnErIcPaste2(a,b) a##b
#endif

#if (defined(USE_PB))
#  define STARTPB(name)                                                 \
          static void* PASTE2(name,_PBPtr) = 0;                         \
          int PASTE2(pb__int_,name) = PBstart(#name,&PASTE2(name,_PBPtr));
#  define ENDPB(name)    PBend(#name)
#  define COMMBytesPB(x) PBcommBytes(x)  
#  define IOBytesPB(x)   PBioBytes(x)  
#  define STARTPB_BLK(name,ptr)   PBstart(#name,ptr)
#  define REPORTPB()              PBreport()
#  define INITPB(fileName,events) PBinit(fileName,events)
#else
#  define STARTPB(name)
#  define STARTPB_BLK(name,ptr)
#  define ENDPB(name)
#  define COMMBytesPB(x)
#  define IOBytesPB(x)
#  define REPORTPB()
#  define INITPB(fileName, events)
#endif

#ifdef __cplusplus
extern "C" {
#endif

void PBinit(const char* file, const char* eventListStr);

int PBstart(const char* fname, void *ptr);

void PBend(const char* fname);

void PBreport();

void PBcommBytes(int bytes);

void PBioBytes(int bytes);


#ifdef __cplusplus
}
#endif

#endif /* PB_USER_H_Included */


