/*
 * This file is part of PB: PerfBench.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include "cpb.h"


void prtoken(Token t, char* word) 
{
  switch (t) 
    {
    case TQUOTE:
    case TCOMMENT:
    case TWORD:
    case TIDENT:
    case TRESERVED:
    case TOTHER:
      /*fprintf(stderr, "prtoken: %s\n", word);*/
      printf("%s", word);
      return;
    case TNL:
      printf("\n");
      return;
    case TSPACE:
      printf(" ");
      return;
    case TTAB:
      printf("\t");
      return;
    case TLPAREN:
      printf("(");
      return;
    case TRPAREN:
      printf(")");
      return;
    case TLBRACE:
      printf("{");
      return;
    case TRBRACE:
      printf("}");
      return;
    case TSTAR:
      printf("*");
      return;
    case TSLASH:
      printf("/");
      return;
    case THASH:
      printf("#");
      return;
    case TCOMMA:
      printf(",");
      return;
    case TSEMI:
      printf(";");
      return;
    case TEOF:
      return;
    default:
      fprintf(stderr, "unknown token: %d (%s)\n", t, word);
      exit(1);
    }
}
